{$M 16384,0,655360}
PROGRAM CALCPi;

CONST LongMax = 32766;

TYPE
     Long = RECORD
              len : INTEGER;
              dat : ARRAY[1..LongMax] OF INTEGER;
            END;
     LongPtr = ^Long;
     pntr = RECORD
               CASE BYTE OF
                 0 : (p : ^INTEGER);
                 1 : (l, h : INTEGER);
              END;

(************************************************************************
  To make it possible to use maximally large arrays, and to increase the
  speed of the computations, all records of type Long MUST start at a
  segment boundary!
*************************************************************************)

VAR pi, angle239 : LongPtr;
    remainder, i, l : INTEGER;
    number : REAL;

PROCEDURE AddLong(VAR answer, add : Long);
BEGIN
  InLine(
         $FC/                    { CLD                      }
         $1E/                    { PUSH    DS               }
         $8E/$5E/<answer+2/      { MOV     DS,[BP+08]       }
         $C4/$76/<add/           { LES     SI,[BP+06]       }
         $26/$8B/$0E/$00/$00/    { MOV     CX,ES:[0000]     }
         $83/$C6/$02/            { ADD     SI,2             }
         $F8/                    { CLC                      }
         $26/$AD/                { LODSW   ES:              }
         $11/$44/$FE/            { ADC     [SI-02],AX       }
         $E2/$F9/                { LOOP    010E             }
         $73/$07/                { JNB     011E             }
         $83/$04/$01/            { ADD Word Ptr [SI],1      }
         $46/                    { INC     SI               }
         $46/                    { INC     SI               }
         $EB/$F7/                { JMP     0115             }
         $1F);                   { POP     DS               }
  WITH answer DO
    IF dat[len+1] <> 0 THEN
      len := len + 1;
END;

PROCEDURE MulLong(VAR a : Long; mul : INTEGER; VAR answer : Long);
BEGIN
  InLine(
         $FC/                    { CLD                      }
         $1E/                    { PUSH    DS               }
         $8E/$5E/<a+2/           { MOV     DS,[BP+0C]       }
         $8B/$5E/<mul/           { MOV     BX,[BP+08]       }
         $C4/$7E/<answer/        { LES     DI,[BP+04]       }
         $8B/$0E/$00/$00/        { MOV     CX,[0000]        }
         $33/$D2/                { XOR     DX,DX            }
         $8B/$F2/                { MOV     SI,DX            }
         $47/                    { INC     DI               }
         $47/                    { INC     DI               }
         $F8/                    { CLC                      }
         $8B/$05/                { MOV     AX,[DI]          }
         $9C/                    { PUSHF                    }
         $F7/$E3/                { MUL     BX               }
         $9D/                    { POPF                     }
         $13/$C6/                { ADC     AX,SI            }
         $AB/                    { STOSW                    }
         $8B/$F2/                { MOV     SI,DX            }
         $E2/$F3/                { LOOP    0114             }
         $83/$D6/$00/            { ADC     SI,+00           }
         $26/$89/$35/            { MOV     ES:[DI],SI       }
         $1F);                   { POP     DS               }
  WITH answer DO
    IF dat[a.len+1] = 0 THEN
      len := a.len
    ELSE
      len := a.len + 1;
END;
 
PROCEDURE DivLong(VAR a : Long; del : INTEGER; VAR answer : Long;
                  VAR remainder : INTEGER);
BEGIN
  InLine(
         $FD/                    { STD                      }
         $1E/                    { PUSH    DS               }
         $8E/$5E/<a+2/           { MOV     DS,[BP+10]       }
         $8B/$5E/<del/           { MOV     BX,[BP+0C]       }
         $C4/$7E/<answer/        { LES     DI,[BP+08]       }
         $8B/$0E/$00/$00/        { MOV     CX,[0000]        }
         $03/$F9/                { ADD     DI,CX            }
         $03/$F9/                { ADD     DI,CX            }
         $33/$D2/                { XOR     DX,DX            }
         $8B/$05/                { MOV     AX,[DI]          }
         $F7/$F3/                { DIV     BX               }
         $AB/                    { STOSW                    }
         $E2/$F9/                { LOOP    0117             }
         $C5/$76/<remainder/     { LDS     SI,[BP+04]       }
         $89/$14/                { MOV     [SI],DX          }
         $1F);                   { POP     DS               }
  WITH answer DO BEGIN
    len := a.len;
    WHILE (dat[len] = 0) AND (len > 1) DO
      len := len - 1;
  END;
END;                                   { DivLong }
 
PROCEDURE SubLong(VAR answer, add : Long);
BEGIN
  InLine(
         $FC/                    { CLD                      }
         $1E/                    { PUSH    DS               }
         $8E/$5E/<answer+2/      { MOV     DS,[BP+08]       }
         $C4/$76/<add/           { LES     SI,[BP+06]       }
         $26/$8B/$0E/$00/$00/    { MOV     CX,ES:[0000]     }
         $83/$C6/$02/            { ADD     SI,2             }
         $F8/                    { CLC                      }
         $26/$AD/                { LODSW   ES:              }
         $19/$44/$FE/            { SBB     [SI-02],AX       }
         $E2/$F9/                { LOOP    012D             }
         $73/$07/                { JNB     013D             }
         $83/$2C/$01/            { SUB Word Ptr [SI],1      }
         $46/                    { INC     SI               }
         $46/                    { INC     SI               }
         $EB/$F7/                { JMP     0134             }
         $1F);                   { POP     DS               }
  WITH answer DO BEGIN
    WHILE (len > 1) AND (dat[len] = 0) DO
      len := len - 1;
  END;
END;                                   { SubLong }

PROCEDURE WritePi(VAR pi : Long);
VAR l, l1, i, r, r1, x : INTEGER;
    utfilnamn:string;
    utfil:text;
BEGIN
  write('Ange utfil : ');
  readln(utfilnamn);
  assign(utfil,utfilnamn);
  rewrite(utfil);
  WITH pi DO BEGIN
    l := len;
    l1 := l - 1;
    i := 1;
    Write(utfil,' Pi = ',dat[l],'.');
    x := 9;
    FOR i := 1 TO Round(number / 4) - 2 DO BEGIN
      IF dat[i] = 0 THEN i := i + 1;
      dat[l] := 0;
      len := l1;
      MulLong(pi,10000,pi);
      r := dat[l];
      r1 := r DIV 100;
      r  := r MOD 100;
      Write(utfil,Chr(r1 DIV 10+48),Chr(r1 MOD 10+48),
            Chr(r DIV 10+48),Chr(r MOD 10+48));
      x := x + 4;
      IF x > 72 THEN BEGIN
        WriteLn(utfil);
        x := 1;
      END;
    END;
  END;
  WriteLn(utfil);
  close(utfil);
END;                                   { WritePi }
 
VAR nin, link : LongPtr;
    words : INTEGER;
 
PROCEDURE ZeroLong(VAR l : Long; size : INTEGER);
BEGIN
  FillChar(l.dat,size*2,#0);
  l.len := words;
END;
 
PROCEDURE CopyLong(VAR fra,til : Long);
BEGIN
  Move(fra,til,words*2+2);
END;
 
PROCEDURE GetLong( VAR p : LongPtr; size : INTEGER);
VAR d : ^BYTE;
    bytes : INTEGER;
BEGIN
  bytes := size + size + 2;
  REPEAT
    GetMem(p,bytes);
    IF Ofs(p^) = 0 THEN BEGIN
      ZeroLong(p^,size);
      Exit;
    END;
    FreeMem(p,bytes);
    New(d);
  UNTIL FALSE;
END;                                   { GetLong }
 
VAR temp : LongPtr;
 
PROCEDURE WriteLong(VAR l : Long; size : INTEGER);
BEGIN
  CopyLong(l,temp^);
  temp^.len := size;
  WritePi(temp^);
END;
 
PROCEDURE ArcCoTan(n : INTEGER; VAR angle : Long);
VAR n2, del, remainder : INTEGER;
    positive : BOOLEAN;
 
BEGIN
  ZeroLong(angle,words);
  ZeroLong(nin^,words);
  ZeroLong(link^,words);
 
  angle.dat[angle.len] := 1;
 
  DivLong(angle,n,angle,remainder);

  n2 := n*n;
  del := 1;
  positive := TRUE;

  CopyLong(angle,nin^);

  REPEAT
    DivLong(nin^,n2,nin^,remainder);
    del := del + 2;
    positive := NOT positive;
    DivLong(nin^,del,link^,remainder);

    IF positive THEN
      AddLong(angle,link^)
    ELSE
      SubLong(angle,link^);
  UNTIL (link^.len <= 1) AND (link^.dat[1] = 0);
END;                                   { ArcCoTan }

BEGIN
  WriteLn('Program to evaluate Pi (3.1415926...) with large precision.');
  Write('Digits(max 40.000): '); ReadLn(number);
  words := Round(number / 4.7);
  GetLong(pi,words+2);
  GetLong(angle239,words+2);
  GetLong(link,words+2);
  GetLong(nin,words+2);
  GetLong(temp,words+2);

  ArcCoTan(5,pi^);         { ATan(1/5) }
  AddLong(pi^,pi^);
  AddLong(pi^,pi^);        { * 4       }

  ArcCoTan(239,angle239^);
  SubLong(pi^,angle239^);
  AddLong(pi^,pi^);
  AddLong(pi^,pi^);        { * 4       }
  WritePi(pi^);
END.

